#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

char s[2005][2005];
int n, m, a, b;

void ucitaj() {
	scanf("%d%d%d%d", &n, &m, &a, &b);
	for (int i=1; i<=n; i++) {
		scanf("%s", s[i]+1);
	}
}

int xl[2005][2005], xr[2005][2005], yl[2005][2005], yr[2005][2005];

void napravi_prefikse() {
	for (int i=1; i<=n; i++) {
		for (int j=1; j<=m; j++) {
			xl[i][j] = xl[i-1][j] + 1;
			yl[i][j] = yl[i][j-1] + 1;
			
			if (s[i][j] == '1') {
				xl[i][j] = yl[i][j] = 0;
			}
		}
	}
	for (int i=n; i>=1; i--) {
		for (int j=m; j>=1; j--) {
			xr[i][j] = xr[i+1][j] + 1;
			yr[i][j] = yr[i][j+1] + 1;
			
			if (s[i][j] == '1') {
				xr[i][j] = yr[i][j] = 0;
			}
		}
	}
}

int osnovno_resenje() {
	int sol = 0;
	for (int i=1; i<=n; i++) {
		for (int j=1; j<=m; j++) {
			if (xl[i][j] >= b) sol++;
			if (yl[i][j] >= b) sol++;
		}
	}
	return sol;	
}

// koliko se mesta gubi preprekom sirine 1 na ovom mestu
inline int cdrop(int x, int y) {
	// return ((x+y-1)-b+1) - max((x-1)-b+1, 0) - max((y-1)-b+1, 0)
	return max(x+y-b, 0) - max(x-b, 0) - max(y-b, 0);
}

// koliko se mesta gubi preprekom sirine a na ovom mestu
inline int vdrop(int x, int y) {
	// return ((x+y+a-1-1)-b+1) - max((x-1)-b+1, 0) - max((y-1)-b+1, 0)
	return max(x+y+a-b-1, 0) - max(x-b, 0) - max(y-b, 0);
}

void resavaj() {
	
	int baza = osnovno_resenje();
	int maxdrop = 0;
	
	int iter_drop_i, iter_drop_j;
	for (int i=1; i<=n; i++) {
		for (int j=1; j<=m; j++) {
			int drop;
			if (j == 1) {
				iter_drop_j = 0;
				for (int k=1; k<=a; k++) { // nije opasno
					iter_drop_j += cdrop(xl[i][k], xr[i][k]);
				}
			} else if (j+a-1 <= m) {
				iter_drop_j -= cdrop(xl[i][j-1], xr[i][j-1]);
				iter_drop_j += cdrop(xl[i][j-1+a], xr[i][j-1+a]);
			}
			drop = iter_drop_j + vdrop(yl[i][j], yr[i][j+a-1]);
			if (yr[i][j] >= a) maxdrop = max(maxdrop, drop);
		}
	}
	
	for (int j=1; j<=m; j++) {
		for (int i=1; i<=n; i++) {
			int drop;
			// stavljamo brod vertikalno
			// gledamo koliko se horizontalnih mesta ukida
			if (i == 1) {
				iter_drop_i = 0;
				for (int k=1; k<=a; k++) { // nije opasno
					iter_drop_i += cdrop(yl[k][j], yr[k][j]);
				}
			} else if (i+a-1 <= n) {
				iter_drop_i -= cdrop(yl[i-1][j], yr[i-1][j]);
				iter_drop_i += cdrop(yl[i+a-1][j], yr[i+a-1][j]);
			}
			drop = iter_drop_i + vdrop(xl[i][j], xr[i+a-1][j]);
			if (xr[i][j] >= a) maxdrop = max(maxdrop, drop);
		}
	}
	
	printf("%d\n", baza - maxdrop);
}

int main() {
	ucitaj();
	napravi_prefikse();
	resavaj();
	return 0;
}