#include <cstdio>
#include <algorithm>

const int N = 100005;

struct question
{
    int id, pos;
    bool answer;
} ;

int n;
question a[N];
int cnt[N][2], max_q;

int seen[N];
bool answer[N];

bool is_valid(int k)
{
    for(int i = 0; i < max_q; i++)
	seen[i] = 0;
    
    for(int i = k - 1; i < n; i += k)
    {
	if(!seen[a[i].id])
	{
	    answer[a[i].id] = a[i].answer;
	    seen[a[i].id] = 1;
	}
	else
	{
	    if(answer[a[i].id] != a[i].answer)
		return false;
	    seen[a[i].id]++;
	}
    }

    for(int i = 0; i < max_q; i++)
    {
	if(cnt[i][0] && cnt[i][1] && !seen[i])
	{
	    return false;
	}
	if(seen[i] && cnt[i][answer[i]] != seen[i])
	    return false;
    }

    return true;
}

int main()
{
    scanf("%d", &n);
    for(int i = 0; i < n; i++)
    {
	char ans[10];
	scanf("%d %s", &a[i].id, &ans);
	a[i].answer = (ans[0] == 'd');
	a[i].pos = i;
    }

    // compress ids
    std::sort(a, a + n, [](question a, question b) {
	    return a.id < b.id;
	});

    int curr_val = 0, curr_id = a[0].id;
    a[0].id = curr_val;
    for(int i = 1; i < n; i++)
	if(a[i].id == curr_id)
	    a[i].id = curr_val;
	else
	{
	    curr_id = a[i].id;
	    curr_val++;
	    a[i].id = curr_val;
	}
    max_q = curr_val + 1;
    
    std::sort(a, a + n, [](question a, question b) {
	    return a.pos < b.pos;
	});

    // precompute cnt
    for(int i = 0; i < n; i++)
	cnt[a[i].id][a[i].answer]++;
    
    // solve
    for(int k = 2; k <= n; k++)
	if(is_valid(k))
	{
	    printf("%d\n", k);
	    return 0;
	}

    printf("-1\n");
    return 0;
}