#include <cstdio>
#include <cmath>
#include <vector>
#include <climits>
#include <algorithm>
using namespace std;
#define maxN 30000

int n;
int a[maxN + 1];
vector<int> p[maxN];
vector<int> pr;
bool f[100000];

void sieve() {
  int n = 100000;
  int sq = (int)sqrt(n);
  for (int i = 2; i <= sq; i++)
    if (!f[i])
      for (int j = i * i; j < n; j += i)
        f[j] = true;
  for (int i = 2; i < n; i++)
    if (!f[i])
      pr.push_back(i);
}

void dec(int x, int id) {
  for (int i = 0; i < pr.size() && x > 1; i++)
    if (x % pr[i] == 0) {
       while (x % pr[i] == 0)
         x /= pr[i];
       p[id].push_back(pr[i]);
    }
  if (x > 1)
    p[id].push_back(x);
  p[id].push_back(INT_MAX);
}

bool gcd(int x, int y) {
  int l = 0;
  int r = 0;
  int n = p[x].size() - 1;
  int m = p[y].size() - 1;
  while (l < n && r < m) {
    if (p[x][l] == p[y][r])
      return false;
    while (p[x][l] < p[y][r])
      l++;
    while (p[x][l] > p[y][r])
      r++;
  }
  return true;
}

int main() {
  scanf("%d", &n);
  sieve();
  for (int i = 0; i < n; i++) {
    scanf("%d", &a[i]);
    dec(a[i], i);
  }
  sort(a, a + n);
  int s = 0;
  int sc;
  int pos = 0;
  while (a[pos] == 1)
    pos++;
  s += pos * (n - 1);
  s -= (pos * (pos - 1)) >> 1;
  int cnt = 1;
  for ( ; pos < n; pos++) {
    if (a[pos] == a[pos + 1]) {
      cnt++;
      continue;
    }
    sc = 0;
    for (int j = pos + 1; j < n; j++)
        if (gcd(pos, j))
          sc++;
    s += cnt * sc;
    cnt = 1;
  }
  printf("%d\n", s);
  return 0;
}