#include <iostream>
#include <vector>
#define MAXD 2000

using namespace std;

bool m[MAXD][MAXD];
pair<int, int> c[MAXD][MAXD];
int x, y, a, b;

int parkh(int px, int py) {
    int blocked = 0;
    for(int i=0; i<a; i++) {
        if(c[px][py-i].first >= b) blocked++;
        for(int j=0; j<a; j++) {
            if(c[px+j][py-i].second==0) break;
            if(c[px+j][py-i].second >= b) blocked++;
        }
    }
    return blocked;
}

int parkv(int px, int py) {
    int blocked = 0;
    for(int i=0; i<a; i++) {
        if(c[px-i][py].second >= b) blocked++;
        for(int j=0; j<a; j++) {
            if(c[px-i][py+j].first==0) break;
            if(c[px-i][py+j].first >= b) blocked++;
        }
    }
    return blocked;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int ways = 0;
    char in;
    cin >> x >> y >> a >> b;
    for(int i=0; i<x; i++)
        for(int j=0; j<y; j++) {
            cin >> in;
            if(in == '1') m[i][j]=true;
        }
    for(int i=0; i<x; i++) {
        for(int j=0; j<y; j++) {
            if(m[i][j]) c[i][j] = make_pair(0, 0);
            else {
                int w, h;
                if(i==0) w=1;
                else w=c[i][j-1].first+1;
                if(j==0) h=1;
                else h=c[i-1][j].second+1;
                c[i][j]=make_pair(w, h);
                if(w >= b) ways++;
                if(h >= b) ways++;
            }
        }
    }

    int min = ways, curr;
    for(int i=2; i<x; i++) {
        for(int j=2; j<y; j++) {
            curr = ways;
            if(c[i][j].first >= a) {
                curr -= parkh(i, j);
                if(curr < min) {min = curr;}
            }
            curr = ways;
            if(c[i][j].second >= a) {
                curr -= parkv(i, j);
                if(curr < min) {min = curr;}
            }
        }
    }

    cout << min;
    return 0;
}