#include <iostream>
#include <vector>
#include <string>
#include <math.h>

enum DIR
{
  DIR_LE = 0,
  DIR_DE = 1,
  DIR_GO = 2,
  DIR_DO = 3
};

typedef struct _brod
{
  int x, y, duzina;
  DIR dir;
} brod;

void SledecaDir(DIR& dir)
{
  if (dir == DIR_DO)
    dir = DIR_DE;
  else if (dir == DIR_DE)
    dir = DIR_GO;
  else if (dir == DIR_GO)
    dir = DIR_LE;
  else
    dir = DIR_DO;
}

int abs(int x)
{
  if (x < 0)
    return -x;
  return x;
}

int Udar(const brod b, const brod a)
{
  bool sudar = false;
  brod duzi  = a;
  brod kraci = b;
  int rxa;
  int rya;
  int rxb;
  int ryb;
  int ra;
  int rb;

  int ax0 = a.x;
  int ay0 = a.y;
  int ax1 = a.x;
  int ay1 = a.y;
  switch(a.dir)
  {
  case DIR_GO:
    ay1 -= a.duzina;
    break;
  case DIR_DO:
    ay1 += a.duzina;
    break;
  case DIR_LE:
    ax1 -= a.duzina;
    break;
  case DIR_DE:
    ax1 += a.duzina;
    break;
  }
  rxa = abs(ax0-ax1);
  rya = abs(ay0-ay1);
  ra  = sqrt(rxa*rxa + rya*rya);

  int bx0 = b.x;
  int by0 = b.y;
  int bx1 = b.x;
  int by1 = b.y;
  switch(b.dir)
  {
  case DIR_GO:
    by1 -= b.duzina;
    rxb = abs(bx0-bx1);
    ryb = abs(by0-by1);
    break;
  case DIR_DO:
    by1 += b.duzina;
    break;
  case DIR_LE:
    bx1 -= b.duzina;
    break;
  case DIR_DE:
    bx1 += b.duzina;
    break;
  }
  rb  = sqrt(rxb*rxb + ryb*ryb);

  if (rb > ra)
  {
    duzi  = b;
    kraci = a;
  }

  if (((bx0 >= ax0) && (bx0 <= ax1)) ||( (by0 >= ay0) && (by0 <= ay1)))
  {
    sudar = true;
  }

  return ((sudar) ? 1 : 0);
}

int main(void)
{
  int n = 0, m = 0, a = 0, b = 0;

  std::cin >> n >> m >> a >> b;

  {
    int mat[n][m];
    std::vector<brod> moguce;
    std::vector<brod> moguce2;

    std::vector<bool> postavljeniX;
    std::vector<bool> postavljeniY;
    std::vector<bool> postavljeniX2;
    std::vector<bool> postavljeniY2;
    postavljeniX.resize(m);
    postavljeniY.resize(n);
    postavljeniX2.resize(m);
    postavljeniY2.resize(n);

    for (int i = 0; i < n;  i++)
    {
      std::string str;
      std::cin >> str;
      for (int j = 0; j < m; j++)
      {
        mat[i][j] = ((str[j] == '0') ? 0:1);
      }
    }

    /* Naci moguce pozicije `a`*/
    {
      for (int i = 0; i < n; i++)
      {
        for (int j = 0; j < m; j++)
        {
          //std::cout << "ij = " << i << ' ' << j << '\n';
          if (mat[i][j] != 0)
          {
            //std::cout << "preskoci\n";
            continue;
          }
          int ttx = j;
          int tty = i;
          bool ok  = false;
          int dirt = 0;
          DIR dir  = DIR_DO;
          int dirtmax = 4;

          int ttx2 = j;
          int tty2 = i;
          bool ok2  = false;
          int dirt2 = 0;
          DIR dir2  = DIR_DO;
          int dirt2max = 4;

          if (b == 1)
          {
            dirt2max = 1;
          }
          if (a == 1)
          {
            dirtmax = 1;
          }

          while (dirt2 < dirt2max)
          {
            //std::cout << "Probaj " << (int) dir << '\n';
            int tx = j, ty = i;
            int t  = b;

            /* t - duzina broda */
            while (t >  0)
            {
              //std::cout << 't' << t << '\n';
              if ((tx >= 0) && (tx < n) && (ty >= 0) && (ty < m))
              {
                if (b == 1)
                {
                  if (mat[ty][tx] != 0)
                  {
                    goto L_NE_MOZE_2;
                  }
                }
                else
                {
                  switch(dir2)
                  {
                  case DIR_DO:
                    if (mat[ty][tx] != 0)
                    {
                      //std::cout << "NE dole " << mat[ty][tx] << " " << tx << '/' << ty << '\n';
                      goto L_NE_MOZE_DIR2;
                    }
                    ty += 1;
                    break;
                  case DIR_LE:
                    if (mat[ty][tx] != 0)
                    {
                      //std::cout << "NE levo\n";
                      goto L_NE_MOZE_DIR2;
                    }
                    tx -= 1;
                    break;
                  case DIR_GO:
                    if (mat[ty][tx] != 0)
                    {
                      //std::cout << "NE gore\n";
                      goto L_NE_MOZE_DIR2;
                    }
                    ty -= 1;
                    break;
                  case DIR_DE:
                    if (mat[ty][tx] != 0)
                    {
                      //std::cout << "NE desno\n";
                      goto L_NE_MOZE_DIR2;
                    }
                    tx += 1;
                    break;
                  }
                }

                t --; /* Prosao jedan deo broda */
              }
              else
              {
                //std::cout << "Van\n";
                goto L_NE_MOZE_VAN2;
              }
            }

            ok2 = false;
            if(b != 1)
            {
              switch(dir2)
              {
              case DIR_GO:
                tty2 += b;
                break;
              case DIR_DO:
                tty2 -= b;
                break;
              case DIR_LE:
                ttx2 -= b;
                break;
              case DIR_DE:
                ttx2 += b;
                break;
              }
            }
            //std::cout << "OK " << (int) dir << '\n';
            //if ((b == 1) || (postavljeniX2.find(ttx) == postavljeniX2.end()) || (postavljeniY2.find(tty) == postavljeniY2.end()))

            {
              if ( (b == 1) || (!((tty2 < n) && (tty2 >= 0) && (ttx2 < m) && (ttx2 >= 0))) || ((!postavljeniX2.at(ttx2)) && (!postavljeniY2.at(tty2))) )
              {
                //std::cout << "MOZE " << (int) dir << '\n';
                brod tb;
                tb.x = i;
                tb.y = j;
                tb.duzina = a;
                tb.dir = dir2;
                //std::cout << "Dodaj @" << i << ',' << j << "DIR: " << (int) dir << 'a' << a << '\n';
                moguce2.push_back(tb);
                postavljeniX2.at(j) = true;
                postavljeniY2.at(i) = true;
              }
            }

L_NE_MOZE_VAN2:
L_NE_MOZE_DIR2:
            dirt2 ++;
            SledecaDir(dir2);
          }
L_NE_MOZE_2:

          ttx = j;
          tty = i;
          ok  = false;
          dirt = 0;
          dir  = DIR_DO;
          while (dirt < dirtmax)
          {
            //std::cout << "Probaj " << (int) dir << '\n';
            int tx = j, ty = i;
            int t  = a;

            /* t - duzina broda */
            while (t > 0)
            {
              //std::cout << 't' << t << '\n';
              if ((tx >= 0) && (tx < n) && (ty >= 0) && (ty < m))
              {
                if (a == 1)
                {
                  if (mat[ty][tx] != 0)
                  {
                    goto L_NE_MOZE;
                  }
                }
                else
                {
                  switch(dir)
                  {
                  case DIR_DO:
                    if (mat[ty][tx] != 0)
                    {
                      //std::cout << "NE dole " << mat[ty][tx] << " " << tx << '/' << ty << '\n';
                      goto L_NE_MOZE_DIR;
                    }
                    ty += 1;
                    break;
                  case DIR_LE:
                    if (mat[ty][tx] != 0)
                    {
                      //std::cout << "NE levo\n";
                      goto L_NE_MOZE_DIR;
                    }
                    tx -= 1;
                    break;
                  case DIR_GO:
                    if (mat[ty][tx] != 0)
                    {
                      //std::cout << "NE gore\n";
                      goto L_NE_MOZE_DIR;
                    }
                    ty -= 1;
                    break;
                  case DIR_DE:
                    if (mat[ty][tx] != 0)
                    {
                      //std::cout << "NE desno\n";
                      goto L_NE_MOZE_DIR;
                    }
                    tx += 1;
                    break;
                  }
                }

                t --; /* Prosao jedan deo broda */
              }
              else
              {
                //std::cout << "Van\n";
                goto L_NE_MOZE_VAN;
              }
            }

            ok = false;
            if (a != 1)
            {
              switch(dir)
              {
              case DIR_GO:
                tty += a;
                break;
              case DIR_DO:
                tty -= a;
                break;
              case DIR_LE:
                ttx -= a;
                break;
              case DIR_DE:
                ttx += a;
                break;
              }
            }
            //std::cout << "OK " << (int) dir << '\n';
            //if ((a == 1) || (postavljeniX.find(ttx) == postavljeniX.end()) || (postavljeniY.find(tty) == postavljeniY.end()))

            {
              if ( (a == 1) || (!((tty < n) && (tty >= 0) && (ttx < m) && (ttx >= 0))) || ((!postavljeniX.at(ttx)) && (!postavljeniY.at(tty))) )
              {
                //std::cout << "MOZE " << (int) dir << '\n';
                brod tb;
                tb.x = i;
                tb.y = j;
                tb.duzina = a;
                tb.dir = dir;
                //std::cout << "Dodaj @" << i << ',' << j << "DIR: " << (int) dir << 'a' << a << '\n';
                moguce.push_back(tb);
                postavljeniX.at(j) = true;
                postavljeniY.at(i) = true;
              }
              //postavljeniX.insert(std::pair<int, bool>(j, true));
              //postavljeniY.insert(std::pair<int, bool>(i, true));
            }

L_NE_MOZE_VAN:
L_NE_MOZE_DIR:
            dirt ++;
            SledecaDir(dir);
          }
L_NE_MOZE:
          continue;
        }
      }
    }

    {
      int l = moguce.size();
      int l2 = moguce2.size();
      /*std::cout << "L2=" << l2 << '\n';
      std::cout << "L=" << l << '\n';
      for (unsigned int i = 0; i < l; i++)
      {
        std::cout << "XY: " << moguce.at(i).x << ' ' << moguce.at(i).y << " DIR " << (int) moguce.at(i).dir << '\n';
      }
      std::cout << '\n';
      for (unsigned int i = 0; i < l2; i++)
      {
        std::cout << "XY: " << moguce2.at(i).x << ' ' << moguce2.at(i).y << " DIR " << (int) moguce2.at(i).dir << '\n';
      }*/
      int br;
      int brMax = 0;
      bool b = false;
      for (unsigned int i = 0; i < l; i++)
      {
        br = 0;
        for (unsigned int j = 0; j < l2; j++)
        {
          br += Udar(moguce.at(i), moguce2.at(j));
        }
        if ((!b) || (br > brMax))
        {
          brMax = br;
          br    = true;
        }
      }
      //std::cout << "Maks br sudara: " << brMax << '\n';
      std::cout << l2-brMax << '\n';

      /* moguce - dzek     */
      /* moguce2 - barbosa */

    }
    /* Manje od 40000000 */
  }

  return 0;
}